/*
 *   Copyright (c) - Ano de 2001               
 *      Anderson de Rezende Rocha - undersun@comp.ufla.br
 *      Joo Guilherme de Mendona Goulart - FALTA O MAIL
 *      Julio Cesar Alves - jcalves@comp.ufla.br
 *
 *      Disciplina de TECNICAS DE PROGRAMACAO
 *      Prof.: Bruno de Oliveira Schneider
 *
 *      Classe de APLICACAO do GRAFO implementado
 *
*/

#include <iostream>
#include <fstream>
#include "grafo.h"

using namespace std;

char Menu();
void MostrarGrafo(clGrafo *grafo);
void CaMiGraDa(clGrafo *grafo);
void ConstruirGrafo(clGrafo *grafo);

///////////////////////////////////////PROGRAMA////////////////////////////////////////
int main()
{
    char opcao;
    char direcional;
    clGrafo* grafo;
    grafo = new clGrafo;
    ConstruirGrafo(grafo);

    do
    {
        opcao = Menu();
        switch (opcao)
        {
            case '1':
                CaMiGraDa(grafo);
                break;
            case '2':
                MostrarGrafo(grafo);
                break;
            case 's':
            case 'S':
                cout << "Programa Desenvolvido por\n" << endl;
                cout << "Anderson de Rezende Rocha" << endl;
                cout << "Joo Guilherme de Mendona Goulart" << endl;
                cout << "Julio Cesar Alves" << endl;
                break;
            default:
                cout << "Opcao invalida" << endl;
        }
    } while(opcao != 's' && opcao != 'S');

    delete grafo;

}

//////////////////////////////////MENU DO PROGRAMA///////////////////////////////////
char Menu()
{
    char opcao;
    char lixo[2];

    cout << "\nCAMINHO MINIMO NUM GRAFO DIRECIONAL ACICLICO (CaMiGraDA)\n\n" << endl;
    cout << "1 - Caminho Minimo de Unica Origem" << endl;
    cout << "2 - Mostrar o Grafo como Lista" << endl;
    cout << "'s' - SAIR do Programa\n" << endl;
    cout << "-> Digite sua opcao: ";
    cin >> opcao;
    cin.getline(lixo,sizeof(lixo));
    return opcao;
}

/////////////////////////////////////EXIBIR O GRAFO//////////////////////////////////////
void MostrarGrafo(clGrafo* grafo)
{
    grafo->MostrarGrafoComoLista();
}

void CaMiGraDa(clGrafo *grafo)
{
    int identificador;
    cout << "Identificador do noh Inicial: ";
    cin >> identificador;
    if (!(grafo->CaMiGraDa(identificador)))
        cout << "Identificador Inexistente no Grafo" << endl;
}

/////////////////////CONSTRUIR O GRAFO A PARTIR DE UMA ARQUIVO/////////////////////
void ConstruirGrafo(clGrafo *grafo)
{
    ifstream arquivo("grafo.bda");
    int nroNohs;
    int idOrigem;
    int idDestino;
    int peso;

    if (!arquivo)
        cout << "Erro: No foi possvel criar ou abrir arquivo \"valores.dat\" " << endl;
    else
    {
        arquivo >> nroNohs;
        while (arquivo >> idOrigem >> idDestino >> peso)
        {
            grafo->InserirNoh(idOrigem);
            grafo->InserirNoh(idDestino);
            grafo->InserirLigacao(idOrigem, idDestino, peso);
        }
    }
}


