/*
 *   Copyright (c) - Ano de 2001               
 *      Anderson de Rezende Rocha - undersun@comp.ufla.br
 *      Joo Guilherme de Mendona Goulart - FALTA O MAIL
 *      Julio Cesar Alves - jcalves@comp.ufla.br
 *
 *      Disciplina de TECNICAS DE PROGRAMACAO
 *      Prof.: Bruno de Oliveira Schneider
 *
*/

#ifndef CLLIGACAO_H
#define CLLIGACAO_H

#include "noh.h"
using namespace std;

class clLigacao
{
    public:
        // Construtores default
        clLigacao();
        clLigacao(clNoh* priDestino);
        clLigacao(clNoh* priDestino, clLigacao* priProxima);
        clLigacao(clNoh* priDestino, clLigacao* priProxima, int priPeso);

        // Consultas
        clNoh* Destino();
        clLigacao* Proxima();
        int Peso();

        // Alteracoes de estado
        void AlterarDestino(clNoh* novoDestino);
        void AlterarProxima(clLigacao* novaProxima);
        void AlterarPeso(int novoPeso);

    private:
        // Noh que esta ligacao aponta
        clNoh* destino;
        // proxima ligacao da lista de ligacoes
        clLigacao* proxima;
        // Peso da ligacao
        int peso;
        void InicializarPonteiros();
};

////////////////////////////////CONSTRUTORES DEFAULT///////////////////////////////////
clLigacao::clLigacao()
{
    InicializarPonteiros();
}

clLigacao::clLigacao(clNoh* priDestino)
{
    InicializarPonteiros();
    AlterarDestino(priDestino);
}

clLigacao::clLigacao(clNoh* priDestino, clLigacao* priProxima)
{
    InicializarPonteiros();
    AlterarDestino(priDestino);
    AlterarProxima(priProxima);
}

clLigacao::clLigacao(clNoh*priDestino,clLigacao*priProxima,int priPeso)
{
    InicializarPonteiros();
    AlterarDestino(priDestino);
    AlterarProxima(priProxima);
    AlterarPeso(priPeso);
}

///////////////////////////////////////CONSULTAS//////////////////////////////////////////
clNoh* clLigacao::Destino()
{
    return destino;
}


clLigacao* clLigacao::Proxima()
{
    return proxima;
}


int clLigacao::Peso()
{
    return peso;
}

////////////////////////////////ALTERACOES DE ESTADO////////////////////////////////////
void clLigacao::AlterarDestino(clNoh* novoDestino)
{
    destino = novoDestino;
}

void clLigacao::AlterarProxima(clLigacao* novaProxima)
{
    proxima = novaProxima;
}

void clLigacao::AlterarPeso(int novoPeso)
{
    peso = novoPeso;
}

///////////////////////////////INICIALIZACAO DE PONTEIROS///////////////////////////////
void clLigacao::InicializarPonteiros()
{
    AlterarDestino(NULL);
    AlterarProxima(NULL);
    AlterarPeso(INFINITO);
}

#endif


