/*
 *	Copyright (c) - Ano de 2001					
 *      Anderson de Rezende Rocha - undersun@comp.ufla.br
 *      Joo Guilherme de Mendona Goulart - FALTA O MAIL
 *      Julio Cesar Alves - jcalves@comp.ufla.br
 *
 *      Disciplina de TECNICAS DE PROGRAMACAO
 *      Prof.: Bruno de Oliveira Schneider
 *
*/

#ifndef CLNOH_H
#define CLNOH_H

#define INFINITO 2147483647

enum clCor { BRANCO, CINZA, PRETO };

class clLigacao;

class clNoh
{
    public:
        // Construtores
        clNoh();
        clNoh(int identidificador);

        // Consultas
        int Id();
        clNoh* Proximo();
        clLigacao* PrimeiraLigacao();

        // Utilizadas pela BuscaProfundidade
        clCor Cor();
        clNoh* Pai();
        int Estimativa();

        // Alteracoes de estado
        void AlterarId(int novoId);
        void AlterarProximo(clNoh* novoProximo);
        void AlterarPrimeiraLigacao(clLigacao* novaPrimeiraLigacao);

        // Utilizadas pela BuscaProfundidade
        void AlterarCor(clCor novaCor);
        void AlterarPai(clNoh* novoPai);
        void AlterarEstimativa(int novaEstimativa);

    private:
        // Identificador do noh
        int id;
        // Noh para o qual este aponta na lista de nohs
        clNoh* proximo;
        // Primeira ligacao da lista de ligacoes deste noh
        clLigacao* primeiraLigacao;

        void InicializarValores();

        // Utilizadas pela BuscaProfundidade
        clCor cor;
        clNoh* pai;
        int estimativa;
};

/////////////////////////////////CONSTRUTORES DEFAULT////////////////////////////////////
clNoh::clNoh()
{
    InicializarValores();
}

clNoh::clNoh(int identificador)
{
    InicializarValores();
    AlterarId(identificador);
}

///////////////////////////////////////CONSULTAS//////////////////////////////////////////
int clNoh::Id()
{
    return id;
}

clNoh* clNoh::Proximo()
{
    return proximo;
}

clLigacao* clNoh::PrimeiraLigacao()
{
    return primeiraLigacao;
}

clCor clNoh::Cor()
{
    return cor;
}

clNoh* clNoh::Pai()
{
    return pai;
}

int clNoh::Estimativa()
{
    return estimativa;
}

////////////////////////////////ALTERACOES DE ESTADO////////////////////////////////////
void clNoh::AlterarId(int novoId)
{
    id = novoId;
}

void clNoh::AlterarProximo(clNoh* novoProximo)
{
        proximo = novoProximo;
}

void clNoh::AlterarPrimeiraLigacao(clLigacao* novaPrimeiraLigacao)
{
        primeiraLigacao = novaPrimeiraLigacao;
}

void clNoh::AlterarCor(clCor novaCor)
{
    cor = novaCor;
}

void clNoh::AlterarPai(clNoh* novoPai)
{
    pai = novoPai;
}

void clNoh::AlterarEstimativa(int novaEstimativa)
{
    estimativa = novaEstimativa;
}

void clNoh::InicializarValores()
{
    AlterarId(INFINITO);
    AlterarProximo(NULL);
    AlterarPrimeiraLigacao(NULL);
}

#include "ligacao.h"

#endif


